<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-danger px-4 py-2" [disabled]="!dataGrid.length" (click)="exportPDF()">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
  <button class="btn btn-success px-4 py-2 ml-2" [disabled]="!dataGrid.length" (click)="printExcel()">
    <i class="fas fa-file-excel mr-2"></i>Excel
  </button>
</app-page-title>

<mat-progress-bar mode="indeterminate" *ngIf="loading" class="m-1"></mat-progress-bar>

<div class="card">
  <div class="row m-1">
    <button (click)="enterado()" [disabled]="!darEnterado"
      [ngClass]="{ 'btn-info':darEnterado, 'btn-outline-info': !darEnterado }" class="btn col btn-enterado m-1 py-2">
      <i class="fas fa-clock mr-2"></i>Enterado
    </button>
    <button (click)="inicio()" [disabled]="!reqInicio"
      [ngClass]="{ 'btn-success':reqInicio, 'btn-outline-success': !reqInicio }" class="btn col btn-inicio m-1 py-2">
      <i class="fas fa-hourglass-start mr-2"></i>Inicio
    </button>
    <button (click)="terminar()" [disabled]="!reqTermino"
      [ngClass]="{ 'btn-dark':reqTermino, 'btn-outline-dark': !reqTermino }" class="btn col btn-terminar m-1 py-2">
      <i class="fas fa-hourglass-end mr-2"></i>Terminar
    </button>
    <button (click)="satisfaccion()" [disabled]="!darSatisf"
      [ngClass]="{ 'btn-primary':darSatisf, 'btn-outline-primary': !darSatisf }" class="btn col btn-satisf m-1 py-2">
      <i class="fas fa-tachometer-alt mr-2"></i>Satisfacción
    </button>
    <button (click)="cancelar()" [disabled]="!cancelado"
      [ngClass]="{ 'btn-danger':cancelado, 'btn-outline-danger': !cancelado }" class="btn col btn-cancelado m-1 py-2">
      <i class="fas fa-ban mr-2"></i>Cancelar
    </button>
  </div>
  <form [formGroup]="searchFormGroup" class="animated fadeIn m-1">
    <div class="row d-flex justify-content-between">
      <div class="form-group col-12 col-sm-6 col-md-6 col-lg-5 col-xl-3">
        <label>Departamento</label>
        <kendo-dropdownlist [data]="dsDeptos" [textField]="'ddesc'" [valueField]="'depto'" [valuePrimitive]="true"
          formControlName="depto" class="w-100">
        </kendo-dropdownlist>
      </div>
      <div class="form-group col-12 col-sm-6 col-md-6 col-lg-5 col-xl-3">
        <label>Estado Actual</label>
        <kendo-dropdownlist [data]="dsEstatus" [textField]="'desc'" [valueField]="'estatus'" [valuePrimitive]="true"
          formControlName="eactual" class="w-100">
        </kendo-dropdownlist>
      </div>
      <div class="form-group col-sm-4 col-md-4 col-lg-2 col-xl-2">
        <label>Desde</label>
        <kendo-datepicker [format]="formatKendo" formControlName="fent" class="w-100 form-control">
        </kendo-datepicker>
      </div>
      <div class="form-group col-sm-4 col-md-4 col-lg-2 col-xl-2">
        <label>Hasta</label>
        <kendo-datepicker [format]="formatKendo" formControlName="fsal" class="w-100 form-control">
        </kendo-datepicker>
      </div>
      <div class="d-flex p-3">
        <button class="btn btn-primary px-4" [disabled]="!searchFormGroup.valid"
          (click)="search(searchFormGroup.value)">
          <i class="fa fa-search mr-2"></i>Buscar
        </button>
      </div>
    </div>
  </form>

  <kendo-grid [kendoGridBinding]="dataGrid" [sortable]="true" [selectable]="true" [resizable]="true"
    [reorderable]="true" style="height:58vh;" [kendoGridSelectBy]="'hnumreq'" [selectedKeys]="mySelection"
    (selectionChange)="selectRow($event)">
    <div *ngIf="dataGrid.length !== 0">
      <kendo-grid-column field="hfecha" title="Fecha" width="130">
        <ng-template kendoGridCellTemplate let-dataItem>
          {{ dataItem.hfecha | date: formatKendo }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="hdepto" title="Depto." width="100"></kendo-grid-column>
      <kendo-grid-column field="hreqgrp" title="Grupo" width="100"></kendo-grid-column>
      <kendo-grid-column field="cuarto" title="Cuarto" width="100"></kendo-grid-column>
      <kendo-grid-column field="hfent" title="Entrada" width="130">
        <ng-template kendoGridCellTemplate let-dataItem>
          {{ dataItem.hfent | date: formatKendo }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="hfsal" title="Salida" width="130">
        <ng-template kendoGridCellTemplate let-dataItem>
          {{ dataItem.hfsal | date: formatKendo }}
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="hnumreq" title="#Req" width="90"></kendo-grid-column>
      <kendo-grid-column field="hdesc" title="Requerimiento"></kendo-grid-column>
      <kendo-grid-column field="hcantidad" title="Cant." width="90"></kendo-grid-column>
      <kendo-grid-column field="eactual" title="E.A." width="90">
      </kendo-grid-column>
      <ng-template kendoGridDetailTemplate let-dataItem>
        <kendo-grid [data]="[dataItem]" [selectable]="true" [resizable]="true" [reorderable]="true">
          <kendo-grid-column field="hnespecial" title="Notas" width="250"></kendo-grid-column>
          <kendo-grid-column field="hhenv" title="Enviado" width="140">
            <ng-template kendoGridCellTemplate let-dataItem>
              {{ dataItem.hhenv | hour }}
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="hhej" title="Enterado" width="140">
            <ng-template kendoGridCellTemplate let-dataItem>
              {{ dataItem.hhej | hour }}
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="hhi" title="Inicio" width="140">
            <ng-template kendoGridCellTemplate let-dataItem>
              {{ dataItem.hhi | hour }}
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="hht" title="Terminado" width="140">
            <ng-template kendoGridCellTemplate let-dataItem>
              {{ dataItem.hht | hour }}
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="hnterm" title="Notas Término" width="250"></kendo-grid-column>
          <kendo-grid-column field="hft" title="Fec. Term." width="112">
            <ng-template kendoGridCellTemplate let-dataItem>
              {{ dataItem.hft | date: formatKendo }}
            </ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="hdur" title="Tiempo" width="140"></kendo-grid-column>
          <kendo-grid-column field="hmd" title="M/D" width="140"></kendo-grid-column>
          <kendo-grid-column field="hdur" title="Duración" width="140"></kendo-grid-column>
          <kendo-grid-column field="hdif" title="Dif (+/-)" width="140"></kendo-grid-column>
          <kendo-grid-column field="satisfaccion" title="Sat." width="140" [filterable]="false"></kendo-grid-column>
          <kendo-grid-column field="hnsatisf" title="Notas Satisfacción" width="250" [filterable]="false">
          </kendo-grid-column>
        </kendo-grid>
      </ng-template>
    </div>
    <ng-template kendoGridNoRecordsTemplate>
      {{ norecords }}
    </ng-template>
  </kendo-grid>

  <ng-template #modalHelp let-c="close" let-d="dismiss">
    <div class="modal-header">
      Información requerida
      <button class="close" aria-label="Close" (click)="d('Cross click')">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <form #formReq="ngForm">
        <div *ngIf="reqSatisf" class="form-group col-sm-12 col-md-12">
          <label>Nivel de Satisfacción</label>
          <kendo-combobox [data]="dsSatisfacciones" [textField]="'sdesc'" [valueField]="'Satisfaccion'"
            [valuePrimitive]="true" [(ngModel)]="requerimiento.satisfaccion" name="satisf" class="w-100" required>
          </kendo-combobox>
        </div>
        <div *ngIf="reqOperador" class="form-group col-sm-12 col-md-12">
          <label>Operador</label>
          <kendo-combobox [data]="dsCamaristas" [textField]="'cnombre'" [valueField]="'camarista'"
            [valuePrimitive]="true" [(ngModel)]="requerimiento.hope" name="hope" class="w-100" required>
          </kendo-combobox>
        </div>
        <div *ngIf="reqnotas" class="form-group col-sm-12 col-md-12">
          <label>Nota</label>
          <textarea autofocus class="form-control" rows="4" name="nota" ngModel required></textarea>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <button class="btn btn-shadow btn-success" [disabled]="!formReq.valid" (click)="guardarNota(formReq.value); c();">
        <i class="fa fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-shadow btn-primary ml-1" (click)="c(); cerrarForm();">
        Cerrar
      </button>
    </div>
  </ng-template>
  <div id="customers" style="display: none;">
    <table id="tbl1">
      <thead>
        <tr>
          <th>Fecha</th>
          <th>Cuarto</th>
          <th># Req.</th>
          <th>Codigo</th>
          <th>Descripción</th>
          <th>Cant.</th>
          <th>Notas</th>
          <th>E.A.</th>
          <th>Enviado</th>
          <th>Enterado</th>
          <th>Inicio</th>
          <th>Terminado</th>
          <th>F.T.</th>
          <th>Tiempo</th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let item of dataGrid">
          <td>{{ item.hfecha }}</td>
          <td>{{ item.cuarto }}</td>
          <td style="text-align: right;">{{ item.hnumreq }}</td>
          <td>{{ item.hreqesp }}</td>
          <td>{{ item.hdesc }}</td>
          <td style="text-align: right;">{{ item.hcantidad }}</td>
          <td>{{ item.hnespecial }}</td>
          <td>{{ item.eactual }}</td>
          <td>{{ item.hhenv | hour }} {{ item.hoenv }}</td>
          <td>{{ item.hhej | hour }} {{ item.hoej }}</td>
          <td>{{ item.hhi | hour }}</td>
          <td>{{ item.hht | hour }}</td>
          <td>{{ item.hft }}</td>
          <td style="text-align: right;">{{ item.hdur }}</td>
        </tr>
        <tr>
          <td></td>
        </tr>
      </tbody>
    </table>

    <table id="tbl2">
      <thead>
        <tr *ngFor="let item of dataTotal">
          <th>{{ item.hreqesp }}</th>
          <th>{{ item.hdesc }}</th>
          <th>{{ item.hcant | number:'1.2-2' }}</th>
        </tr>
      </thead>
    </table>
  </div>